diff --git a/src/backend/storage/lmgr/proc.c b/src/backend/storage/lmgr/proc.c
index 5f6727d501..121cd93013 100644
--- a/src/backend/storage/lmgr/proc.c
+++ b/src/backend/storage/lmgr/proc.c
@@ -365,7 +365,7 @@ InitProcess(void)
 	MyProc->fpVXIDLock = false;
 	MyProc->fpLocalTransactionId = InvalidLocalTransactionId;
 	MyPgXact->xid = InvalidTransactionId;
-	MyPgXact->xmin = InvalidTransactionId;
+	MyPgXact->snapshotcsn = InvalidCommitSeqNo;
 	MyProc->pid = MyProcPid;
 	/* backendId, databaseId and roleId will be filled in later */
 	MyProc->backendId = InvalidBackendId;
@@ -412,9 +412,10 @@ InitProcess(void)
 	/* Initialize fields for group transaction status update. */
 	MyProc->clogGroupMember = false;
 	MyProc->clogGroupMemberXid = InvalidTransactionId;
-	MyProc->clogGroupMemberXidStatus = TRANSACTION_STATUS_IN_PROGRESS;
+	MyProc->clogGroupMemberXidStatus = CLOG_XID_STATUS_IN_PROGRESS;
 	MyProc->clogGroupMemberPage = -1;
 	MyProc->clogGroupMemberLsn = InvalidXLogRecPtr;
+	MyProc->clogGroupNSubxids = 0;
 	pg_atomic_init_u32(&MyProc->clogGroupNext, INVALID_PGPROCNO);
 
 	/*
@@ -548,7 +549,7 @@ InitAuxiliaryProcess(void)
 	MyProc->fpVXIDLock = false;
 	MyProc->fpLocalTransactionId = InvalidLocalTransactionId;
 	MyPgXact->xid = InvalidTransactionId;
-	MyPgXact->xmin = InvalidTransactionId;
+	MyPgXact->snapshotcsn = InvalidCommitSeqNo;
 	MyProc->backendId = InvalidBackendId;
 	MyProc->databaseId = InvalidOid;
 	MyProc->roleId = InvalidOid;
@@ -779,7 +780,7 @@ static void
 RemoveProcFromArray(int code, Datum arg)
 {
 	Assert(MyProc != NULL);
-	ProcArrayRemove(MyProc, InvalidTransactionId);
+	ProcArrayRemove(MyProc);
 }
 
 /*
diff --git a/src/backend/utils/adt/enum.c b/src/backend/utils/adt/enum.c
index 973397cc85..93390c19c4 100644
--- a/src/backend/utils/adt/enum.c
+++ b/src/backend/utils/adt/enum.c
@@ -72,8 +72,7 @@ check_safe_enum_use(HeapTuple enumval_tup)
 	 * into syscache; but just in case not, let's check the xmin directly.
 	 */
 	xmin = HeapTupleHeaderGetXmin(enumval_tup->t_data);
-	if (!TransactionIdIsInProgress(xmin) &&
-		TransactionIdDidCommit(xmin))
+	if (TransactionIdDidCommit(xmin))
 		return;
 
 	/* It is a new enum value, so check to see if the whole enum is new */
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index 81b0bc37d2..969552038c 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -130,6 +130,7 @@
 #include "parser/parse_coerce.h"
 #include "parser/parsetree.h"
 #include "statistics/statistics.h"
+#include "storage/procarray.h"
 #include "utils/acl.h"
 #include "utils/builtins.h"
 #include "utils/bytea.h"
@@ -5352,7 +5353,7 @@ get_actual_variable_range(PlannerInfo *root, VariableStatData *vardata,
 			slot = MakeSingleTupleTableSlot(RelationGetDescr(heapRel));
 			econtext->ecxt_scantuple = slot;
 			get_typlenbyval(vardata->atttype, &typLen, &typByVal);
-			InitNonVacuumableSnapshot(SnapshotNonVacuumable, RecentGlobalXmin);
+			InitNonVacuumableSnapshot(SnapshotNonVacuumable, GetRecentGlobalXmin());
 
 			/* set up an IS NOT NULL scan key so that we ignore nulls */
 			ScanKeyEntryInitialize(&scankeys[0],
diff --git a/src/backend/utils/adt/txid.c b/src/backend/utils/adt/txid.c
index 1e38ca2aa5..16a3663f1e 100644
--- a/src/backend/utils/adt/txid.c
+++ b/src/backend/utils/adt/txid.c
@@ -22,6 +22,7 @@
 #include "postgres.h"
 
 #include "access/clog.h"
+#include "access/mvccvars.h"
 #include "access/transam.h"
 #include "access/xact.h"
 #include "access/xlog.h"
@@ -53,6 +54,8 @@ typedef uint64 txid;
 
 /*
  * Snapshot containing 8byte txids.
+ *
+ * FIXME: this could be a fixed-length datatype now.
  */
 typedef struct
 {
@@ -63,17 +66,16 @@ typedef struct
 	 */
 	int32		__varsz;
 
-	uint32		nxip;			/* number of txids in xip array */
-	txid		xmin;
 	txid		xmax;
-	/* in-progress txids, xmin <= xip[i] < xmax: */
-	txid		xip[FLEXIBLE_ARRAY_MEMBER];
+	/*
+	 * FIXME: this is change in on-disk format if someone created a column
+	 * with txid datatype. Dump+reload won't load either.
+	 */
+	CommitSeqNo	snapshotcsn;
 } TxidSnapshot;
 
-#define TXID_SNAPSHOT_SIZE(nxip) \
-	(offsetof(TxidSnapshot, xip) + sizeof(txid) * (nxip))
-#define TXID_SNAPSHOT_MAX_NXIP \
-	((MaxAllocSize - offsetof(TxidSnapshot, xip)) / sizeof(txid))
+#define TXID_SNAPSHOT_SIZE \
+	(offsetof(TxidSnapshot, snapshotcsn) + sizeof(CommitSeqNo))
 
 /*
  * Epoch values from xact.c
@@ -183,60 +185,12 @@ convert_xid(TransactionId xid, const TxidEpoch *state)
 }
 
 /*
- * txid comparator for qsort/bsearch
- */
-static int
-cmp_txid(const void *aa, const void *bb)
-{
-	txid		a = *(const txid *) aa;
-	txid		b = *(const txid *) bb;
-
-	if (a < b)
-		return -1;
-	if (a > b)
-		return 1;
-	return 0;
-}
-
-/*
- * Sort a snapshot's txids, so we can use bsearch() later.  Also remove
- * any duplicates.
- *
- * For consistency of on-disk representation, we always sort even if bsearch
- * will not be used.
- */
-static void
-sort_snapshot(TxidSnapshot *snap)
-{
-	txid		last = 0;
-	int			nxip,
-				idx1,
-				idx2;
-
-	if (snap->nxip > 1)
-	{
-		qsort(snap->xip, snap->nxip, sizeof(txid), cmp_txid);
-
-		/* remove duplicates */
-		nxip = snap->nxip;
-		idx1 = idx2 = 0;
-		while (idx1 < nxip)
-		{
-			if (snap->xip[idx1] != last)
-				last = snap->xip[idx2++] = snap->xip[idx1];
-			else
-				snap->nxip--;
-			idx1++;
-		}
-	}
-}
-
-/*
  * check txid visibility.
  */
 static bool
 is_visible_txid(txid value, const TxidSnapshot *snap)
 {
+#ifdef BROKEN
 	if (value < snap->xmin)
 		return true;
 	else if (value >= snap->xmax)
@@ -262,50 +216,8 @@ is_visible_txid(txid value, const TxidSnapshot *snap)
 		}
 		return true;
 	}
-}
-
-/*
- * helper functions to use StringInfo for TxidSnapshot creation.
- */
-
-static StringInfo
-buf_init(txid xmin, txid xmax)
-{
-	TxidSnapshot snap;
-	StringInfo	buf;
-
-	snap.xmin = xmin;
-	snap.xmax = xmax;
-	snap.nxip = 0;
-
-	buf = makeStringInfo();
-	appendBinaryStringInfo(buf, (char *) &snap, TXID_SNAPSHOT_SIZE(0));
-	return buf;
-}
-
-static void
-buf_add_txid(StringInfo buf, txid xid)
-{
-	TxidSnapshot *snap = (TxidSnapshot *) buf->data;
-
-	/* do this before possible realloc */
-	snap->nxip++;
-
-	appendBinaryStringInfo(buf, (char *) &xid, sizeof(xid));
-}
-
-static TxidSnapshot *
-buf_finalize(StringInfo buf)
-{
-	TxidSnapshot *snap = (TxidSnapshot *) buf->data;
-
-	SET_VARSIZE(snap, buf->len);
-
-	/* buf is not needed anymore */
-	buf->data = NULL;
-	pfree(buf);
-
-	return snap;
+#endif
+	return false;
 }
 
 /*
@@ -350,54 +262,29 @@ str2txid(const char *s, const char **endp)
 static TxidSnapshot *
 parse_snapshot(const char *str)
 {
-	txid		xmin;
-	txid		xmax;
-	txid		last_val = 0,
-				val;
 	const char *str_start = str;
 	const char *endp;
-	StringInfo	buf;
+	TxidSnapshot *snap;
+	uint32		csn_hi,
+				csn_lo;
 
-	xmin = str2txid(str, &endp);
-	if (*endp != ':')
-		goto bad_format;
-	str = endp + 1;
+	snap = palloc0(TXID_SNAPSHOT_SIZE);
+	SET_VARSIZE(snap, TXID_SNAPSHOT_SIZE);
 
-	xmax = str2txid(str, &endp);
+	snap->xmax = str2txid(str, &endp);
 	if (*endp != ':')
 		goto bad_format;
 	str = endp + 1;
 
 	/* it should look sane */
-	if (xmin == 0 || xmax == 0 || xmin > xmax)
+	if (snap->xmax == 0)
 		goto bad_format;
 
-	/* allocate buffer */
-	buf = buf_init(xmin, xmax);
-
-	/* loop over values */
-	while (*str != '\0')
-	{
-		/* read next value */
-		val = str2txid(str, &endp);
-		str = endp;
-
-		/* require the input to be in order */
-		if (val < xmin || val >= xmax || val < last_val)
-			goto bad_format;
-
-		/* skip duplicates */
-		if (val != last_val)
-			buf_add_txid(buf, val);
-		last_val = val;
-
-		if (*str == ',')
-			str++;
-		else if (*str != '\0')
-			goto bad_format;
-	}
+	if (sscanf(str, "%X/%X", &csn_hi, &csn_lo) != 2)
+		goto bad_format;
+	snap->snapshotcsn = ((uint64) csn_hi) << 32 | csn_lo;
 
-	return buf_finalize(buf);
+	return snap;
 
 bad_format:
 	ereport(ERROR,
@@ -477,8 +364,6 @@ Datum
 txid_current_snapshot(PG_FUNCTION_ARGS)
 {
 	TxidSnapshot *snap;
-	uint32		nxip,
-				i;
 	TxidEpoch	state;
 	Snapshot	cur;
 
@@ -488,35 +373,13 @@ txid_current_snapshot(PG_FUNCTION_ARGS)
 
 	load_xid_epoch(&state);
 
-	/*
-	 * Compile-time limits on the procarray (MAX_BACKENDS processes plus
-	 * MAX_BACKENDS prepared transactions) guarantee nxip won't be too large.
-	 */
-	StaticAssertStmt(MAX_BACKENDS * 2 <= TXID_SNAPSHOT_MAX_NXIP,
-					 "possible overflow in txid_current_snapshot()");
-
 	/* allocate */
-	nxip = cur->xcnt;
-	snap = palloc(TXID_SNAPSHOT_SIZE(nxip));
+	snap = palloc(TXID_SNAPSHOT_SIZE);
+	SET_VARSIZE(snap, TXID_SNAPSHOT_SIZE);
 
 	/* fill */
-	snap->xmin = convert_xid(cur->xmin, &state);
 	snap->xmax = convert_xid(cur->xmax, &state);
-	snap->nxip = nxip;
-	for (i = 0; i < nxip; i++)
-		snap->xip[i] = convert_xid(cur->xip[i], &state);
-
-	/*
-	 * We want them guaranteed to be in ascending order.  This also removes
-	 * any duplicate xids.  Normally, an XID can only be assigned to one
-	 * backend, but when preparing a transaction for two-phase commit, there
-	 * is a transient state when both the original backend and the dummy
-	 * PGPROC entry reserved for the prepared transaction hold the same XID.
-	 */
-	sort_snapshot(snap);
-
-	/* set size after sorting, because it may have removed duplicate xips */
-	SET_VARSIZE(snap, TXID_SNAPSHOT_SIZE(snap->nxip));
+	snap->snapshotcsn = cur->snapshotcsn;
 
 	PG_RETURN_POINTER(snap);
 }
@@ -547,19 +410,12 @@ txid_snapshot_out(PG_FUNCTION_ARGS)
 {
 	TxidSnapshot *snap = (TxidSnapshot *) PG_GETARG_VARLENA_P(0);
 	StringInfoData str;
-	uint32		i;
 
 	initStringInfo(&str);
 
-	appendStringInfo(&str, TXID_FMT ":", snap->xmin);
 	appendStringInfo(&str, TXID_FMT ":", snap->xmax);
-
-	for (i = 0; i < snap->nxip; i++)
-	{
-		if (i > 0)
-			appendStringInfoChar(&str, ',');
-		appendStringInfo(&str, TXID_FMT, snap->xip[i]);
-	}
+	appendStringInfo(&str, "%X/%X", (uint32) (snap->snapshotcsn >> 32),
+					 (uint32) snap->snapshotcsn);
 
 	PG_RETURN_CSTRING(str.data);
 }
@@ -574,6 +430,7 @@ txid_snapshot_out(PG_FUNCTION_ARGS)
 Datum
 txid_snapshot_recv(PG_FUNCTION_ARGS)
 {
+#ifdef BROKEN
 	StringInfo	buf = (StringInfo) PG_GETARG_POINTER(0);
 	TxidSnapshot *snap;
 	txid		last = 0;
@@ -582,11 +439,6 @@ txid_snapshot_recv(PG_FUNCTION_ARGS)
 	txid		xmin,
 				xmax;
 
-	/* load and validate nxip */
-	nxip = pq_getmsgint(buf, 4);
-	if (nxip < 0 || nxip > TXID_SNAPSHOT_MAX_NXIP)
-		goto bad_format;
-
 	xmin = pq_getmsgint64(buf);
 	xmax = pq_getmsgint64(buf);
 	if (xmin == 0 || xmax == 0 || xmin > xmax || xmax > MAX_TXID)
@@ -619,6 +471,7 @@ txid_snapshot_recv(PG_FUNCTION_ARGS)
 	PG_RETURN_POINTER(snap);
 
 bad_format:
+#endif
 	ereport(ERROR,
 			(errcode(ERRCODE_INVALID_BINARY_REPRESENTATION),
 			 errmsg("invalid external txid_snapshot data")));
@@ -637,14 +490,13 @@ txid_snapshot_send(PG_FUNCTION_ARGS)
 {
 	TxidSnapshot *snap = (TxidSnapshot *) PG_GETARG_VARLENA_P(0);
 	StringInfoData buf;
-	uint32		i;
 
 	pq_begintypsend(&buf);
-	pq_sendint(&buf, snap->nxip, 4);
+#ifdef BROKEN
 	pq_sendint64(&buf, snap->xmin);
 	pq_sendint64(&buf, snap->xmax);
-	for (i = 0; i < snap->nxip; i++)
-		pq_sendint64(&buf, snap->xip[i]);
+#endif
+	pq_sendint64(&buf, snap->snapshotcsn);
 	PG_RETURN_BYTEA_P(pq_endtypsend(&buf));
 }
 
@@ -665,14 +517,18 @@ txid_visible_in_snapshot(PG_FUNCTION_ARGS)
 /*
  * txid_snapshot_xmin(txid_snapshot) returns int8
  *
- *		return snapshot's xmin
+ *             return snapshot's xmin
  */
 Datum
 txid_snapshot_xmin(PG_FUNCTION_ARGS)
 {
+	/* FIXME: we don't store xmin in the TxidSnapshot anymore. Maybe we still should? */
+#ifdef BROKEN
 	TxidSnapshot *snap = (TxidSnapshot *) PG_GETARG_VARLENA_P(0);
 
 	PG_RETURN_INT64(snap->xmin);
+#endif
+	PG_RETURN_INT64(0);
 }
 
 /*
@@ -687,47 +543,6 @@ txid_snapshot_xmax(PG_FUNCTION_ARGS)
 
 	PG_RETURN_INT64(snap->xmax);
 }
-
-/*
- * txid_snapshot_xip(txid_snapshot) returns setof int8
- *
- *		return in-progress TXIDs in snapshot.
- */
-Datum
-txid_snapshot_xip(PG_FUNCTION_ARGS)
-{
-	FuncCallContext *fctx;
-	TxidSnapshot *snap;
-	txid		value;
-
-	/* on first call initialize snap_state and get copy of snapshot */
-	if (SRF_IS_FIRSTCALL())
-	{
-		TxidSnapshot *arg = (TxidSnapshot *) PG_GETARG_VARLENA_P(0);
-
-		fctx = SRF_FIRSTCALL_INIT();
-
-		/* make a copy of user snapshot */
-		snap = MemoryContextAlloc(fctx->multi_call_memory_ctx, VARSIZE(arg));
-		memcpy(snap, arg, VARSIZE(arg));
-
-		fctx->user_fctx = snap;
-	}
-
-	/* return values one-by-one */
-	fctx = SRF_PERCALL_SETUP();
-	snap = fctx->user_fctx;
-	if (fctx->call_cntr < snap->nxip)
-	{
-		value = snap->xip[fctx->call_cntr];
-		SRF_RETURN_NEXT(fctx, Int64GetDatum(value));
-	}
-	else
-	{
-		SRF_RETURN_DONE(fctx);
-	}
-}
-
 /*
  * Report the status of a recent transaction ID, or null for wrapped,
  * truncated away or otherwise too old XIDs.
diff --git a/src/backend/utils/probes.d b/src/backend/utils/probes.d
index 214dc712ca..c58d6adb6f 100644
--- a/src/backend/utils/probes.d
+++ b/src/backend/utils/probes.d
@@ -75,6 +75,8 @@ provider postgresql {
 	probe checkpoint__done(int, int, int, int, int);
 	probe clog__checkpoint__start(bool);
 	probe clog__checkpoint__done(bool);
+	probe csnlog__checkpoint__start(bool);
+	probe csnlog__checkpoint__done(bool);
 	probe subtrans__checkpoint__start(bool);
 	probe subtrans__checkpoint__done(bool);
 	probe multixact__checkpoint__start(bool);
